<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: MFRC522.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">MFRC522.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="preprocessor">#ifndef MFRC522_h</span></div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="preprocessor">#define MFRC522_h</span></div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="preprocessor">#include &lt;SPI.h&gt;</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="keyword">typedef</span> uint8_t byte;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="comment">// Firmware data for self-test</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="comment">// Reference values based on firmware version</span></div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="comment">// Hint: if needed, you can remove unused self-test data to save flash memory</span></div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="comment">// Version 0.0 (0x90)</span></div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="comment">// Philips Semiconductors; Preliminary Specification Revision 2.0 - 01 August 2005; 16.1 self-test</span></div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="keyword">const</span> <span class="keywordtype">byte</span> MFRC522_firmware_referenceV0_0[] = {</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    0x00, 0x87, 0x98, 0x0f, 0x49, 0xFF, 0x07, 0x19,</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    0xBF, 0x22, 0x30, 0x49, 0x59, 0x63, 0xAD, 0xCA,</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    0x7F, 0xE3, 0x4E, 0x03, 0x5C, 0x4E, 0x49, 0x50,</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    0x47, 0x9A, 0x37, 0x61, 0xE7, 0xE2, 0xC6, 0x2E,</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    0x75, 0x5A, 0xED, 0x04, 0x3D, 0x02, 0x4B, 0x78,</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    0x32, 0xFF, 0x58, 0x3B, 0x7C, 0xE9, 0x00, 0x94,</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    0xB4, 0x4A, 0x59, 0x5B, 0xFD, 0xC9, 0x29, 0xDF,</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    0x35, 0x96, 0x98, 0x9E, 0x4F, 0x30, 0x32, 0x8D</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;};</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="comment">// Version 1.0 (0x91)</span></div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="comment">// NXP Semiconductors; Rev. 3.8 - 17 September 2014; 16.1.1 self-test</span></div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="keyword">const</span> <span class="keywordtype">byte</span> MFRC522_firmware_referenceV1_0[] = {</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    0x00, 0xC6, 0x37, 0xD5, 0x32, 0xB7, 0x57, 0x5C,</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    0xC2, 0xD8, 0x7C, 0x4D, 0xD9, 0x70, 0xC7, 0x73,</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    0x10, 0xE6, 0xD2, 0xAA, 0x5E, 0xA1, 0x3E, 0x5A,</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    0x14, 0xAF, 0x30, 0x61, 0xC9, 0x70, 0xDB, 0x2E,</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    0x64, 0x22, 0x72, 0xB5, 0xBD, 0x65, 0xF4, 0xEC,</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    0x22, 0xBC, 0xD3, 0x72, 0x35, 0xCD, 0xAA, 0x41,</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    0x1F, 0xA7, 0xF3, 0x53, 0x14, 0xDE, 0x7E, 0x02,</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    0xD9, 0x0F, 0xB5, 0x5E, 0x25, 0x1D, 0x29, 0x79</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;};</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="comment">// Version 2.0 (0x92)</span></div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="comment">// NXP Semiconductors; Rev. 3.8 - 17 September 2014; 16.1.1 self-test</span></div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="keyword">const</span> <span class="keywordtype">byte</span> MFRC522_firmware_referenceV2_0[] = {</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    0x00, 0xEB, 0x66, 0xBA, 0x57, 0xBF, 0x23, 0x95,</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    0xD0, 0xE3, 0x0D, 0x3D, 0x27, 0x89, 0x5C, 0xDE,</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    0x9D, 0x3B, 0xA7, 0x00, 0x21, 0x5B, 0x89, 0x82,</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    0x51, 0x3A, 0xEB, 0x02, 0x0C, 0xA5, 0x00, 0x49,</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    0x7C, 0x84, 0x4D, 0xB3, 0xCC, 0xD2, 0x1B, 0x81,</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    0x5D, 0x48, 0x76, 0xD5, 0x71, 0x61, 0x21, 0xA9,</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    0x86, 0x96, 0x83, 0x38, 0xCF, 0x9D, 0x5B, 0x6D,</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    0xDC, 0x15, 0xBA, 0x3E, 0x7D, 0x95, 0x3B, 0x2F</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;};</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="comment">// Clone</span></div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="comment">// Fudan Semiconductor FM17522 (0x88)</span></div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="keyword">const</span> <span class="keywordtype">byte</span> FM17522_firmware_reference[] = {</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    0x00, 0xD6, 0x78, 0x8C, 0xE2, 0xAA, 0x0C, 0x18,</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    0x2A, 0xB8, 0x7A, 0x7F, 0xD3, 0x6A, 0xCF, 0x0B,</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    0xB1, 0x37, 0x63, 0x4B, 0x69, 0xAE, 0x91, 0xC7,</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    0xC3, 0x97, 0xAE, 0x77, 0xF4, 0x37, 0xD7, 0x9B,</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    0x7C, 0xF5, 0x3C, 0x11, 0x8F, 0x15, 0xC3, 0xD7,</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    0xC1, 0x5B, 0x00, 0x2A, 0xD0, 0x75, 0xDE, 0x9E,</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    0x51, 0x64, 0xAB, 0x3E, 0xE9, 0x15, 0xB5, 0xAB,</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    0x56, 0x9A, 0x98, 0x82, 0x26, 0xEA, 0x2A, 0x62</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;};</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno"><a class="line" href="classMFRC522.html">  137</a></span>&#160;<span class="keyword">class </span><a class="code" href="classMFRC522.html">MFRC522</a> {</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <span class="comment">// Size of the MFRC522 FIFO</span></div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <span class="keyword">static</span> constexpr <span class="keywordtype">byte</span> FIFO_SIZE = 64;       <span class="comment">// The FIFO is 64 bytes.</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    <span class="comment">// Default value for unused pin</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <span class="keyword">static</span> constexpr uint8_t UNUSED_PIN = UINT8_MAX;</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <span class="comment">// MFRC522 registers. Described in chapter 9 of the datasheet.</span></div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    <span class="comment">// When using SPI all addresses are shifted one bit left in the &quot;SPI address byte&quot; (section 8.1.2.3)</span></div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    <span class="keyword">enum</span> PCD_Register : <span class="keywordtype">byte</span> {</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <span class="comment">// Page 0: Command and status</span></div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="comment">//                        0x00          // reserved for future use</span></div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        CommandReg              = 0x01 &lt;&lt; 1,    <span class="comment">// starts and stops command execution</span></div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        ComIEnReg               = 0x02 &lt;&lt; 1,    <span class="comment">// enable and disable interrupt request control bits</span></div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        DivIEnReg               = 0x03 &lt;&lt; 1,    <span class="comment">// enable and disable interrupt request control bits</span></div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        ComIrqReg               = 0x04 &lt;&lt; 1,    <span class="comment">// interrupt request bits</span></div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        DivIrqReg               = 0x05 &lt;&lt; 1,    <span class="comment">// interrupt request bits</span></div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        ErrorReg                = 0x06 &lt;&lt; 1,    <span class="comment">// error bits showing the error status of the last command executed</span></div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        Status1Reg              = 0x07 &lt;&lt; 1,    <span class="comment">// communication status bits</span></div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        Status2Reg              = 0x08 &lt;&lt; 1,    <span class="comment">// receiver and transmitter status bits</span></div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        FIFODataReg             = 0x09 &lt;&lt; 1,    <span class="comment">// input and output of 64 byte FIFO buffer</span></div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        FIFOLevelReg            = 0x0A &lt;&lt; 1,    <span class="comment">// number of bytes stored in the FIFO buffer</span></div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        WaterLevelReg           = 0x0B &lt;&lt; 1,    <span class="comment">// level for FIFO underflow and overflow warning</span></div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        ControlReg              = 0x0C &lt;&lt; 1,    <span class="comment">// miscellaneous control registers</span></div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        BitFramingReg           = 0x0D &lt;&lt; 1,    <span class="comment">// adjustments for bit-oriented frames</span></div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        CollReg                 = 0x0E &lt;&lt; 1,    <span class="comment">// bit position of the first bit-collision detected on the RF interface</span></div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        <span class="comment">//                        0x0F          // reserved for future use</span></div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        <span class="comment">// Page 1: Command</span></div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        <span class="comment">//                        0x10          // reserved for future use</span></div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        ModeReg                 = 0x11 &lt;&lt; 1,    <span class="comment">// defines general modes for transmitting and receiving</span></div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        TxModeReg               = 0x12 &lt;&lt; 1,    <span class="comment">// defines transmission data rate and framing</span></div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        RxModeReg               = 0x13 &lt;&lt; 1,    <span class="comment">// defines reception data rate and framing</span></div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        TxControlReg            = 0x14 &lt;&lt; 1,    <span class="comment">// controls the logical behavior of the antenna driver pins TX1 and TX2</span></div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        TxASKReg                = 0x15 &lt;&lt; 1,    <span class="comment">// controls the setting of the transmission modulation</span></div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        TxSelReg                = 0x16 &lt;&lt; 1,    <span class="comment">// selects the internal sources for the antenna driver</span></div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        RxSelReg                = 0x17 &lt;&lt; 1,    <span class="comment">// selects internal receiver settings</span></div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        RxThresholdReg          = 0x18 &lt;&lt; 1,    <span class="comment">// selects thresholds for the bit decoder</span></div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        DemodReg                = 0x19 &lt;&lt; 1,    <span class="comment">// defines demodulator settings</span></div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        <span class="comment">//                        0x1A          // reserved for future use</span></div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        <span class="comment">//                        0x1B          // reserved for future use</span></div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        MfTxReg                 = 0x1C &lt;&lt; 1,    <span class="comment">// controls some MIFARE communication transmit parameters</span></div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        MfRxReg                 = 0x1D &lt;&lt; 1,    <span class="comment">// controls some MIFARE communication receive parameters</span></div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        <span class="comment">//                        0x1E          // reserved for future use</span></div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        SerialSpeedReg          = 0x1F &lt;&lt; 1,    <span class="comment">// selects the speed of the serial UART interface</span></div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        <span class="comment">// Page 2: Configuration</span></div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        <span class="comment">//                        0x20          // reserved for future use</span></div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        CRCResultRegH           = 0x21 &lt;&lt; 1,    <span class="comment">// shows the MSB and LSB values of the CRC calculation</span></div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        CRCResultRegL           = 0x22 &lt;&lt; 1,</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        <span class="comment">//                        0x23          // reserved for future use</span></div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        ModWidthReg             = 0x24 &lt;&lt; 1,    <span class="comment">// controls the ModWidth setting?</span></div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        <span class="comment">//                        0x25          // reserved for future use</span></div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        RFCfgReg                = 0x26 &lt;&lt; 1,    <span class="comment">// configures the receiver gain</span></div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        GsNReg                  = 0x27 &lt;&lt; 1,    <span class="comment">// selects the conductance of the antenna driver pins TX1 and TX2 for modulation</span></div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        CWGsPReg                = 0x28 &lt;&lt; 1,    <span class="comment">// defines the conductance of the p-driver output during periods of no modulation</span></div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        ModGsPReg               = 0x29 &lt;&lt; 1,    <span class="comment">// defines the conductance of the p-driver output during periods of modulation</span></div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        TModeReg                = 0x2A &lt;&lt; 1,    <span class="comment">// defines settings for the internal timer</span></div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        TPrescalerReg           = 0x2B &lt;&lt; 1,    <span class="comment">// the lower 8 bits of the TPrescaler value. The 4 high bits are in TModeReg.</span></div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        TReloadRegH             = 0x2C &lt;&lt; 1,    <span class="comment">// defines the 16-bit timer reload value</span></div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        TReloadRegL             = 0x2D &lt;&lt; 1,</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        TCounterValueRegH       = 0x2E &lt;&lt; 1,    <span class="comment">// shows the 16-bit timer value</span></div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        TCounterValueRegL       = 0x2F &lt;&lt; 1,</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        <span class="comment">// Page 3: Test Registers</span></div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        <span class="comment">//                        0x30          // reserved for future use</span></div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        TestSel1Reg             = 0x31 &lt;&lt; 1,    <span class="comment">// general test signal configuration</span></div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        TestSel2Reg             = 0x32 &lt;&lt; 1,    <span class="comment">// general test signal configuration</span></div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        TestPinEnReg            = 0x33 &lt;&lt; 1,    <span class="comment">// enables pin output driver on pins D1 to D7</span></div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        TestPinValueReg         = 0x34 &lt;&lt; 1,    <span class="comment">// defines the values for D1 to D7 when it is used as an I/O bus</span></div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        TestBusReg              = 0x35 &lt;&lt; 1,    <span class="comment">// shows the status of the internal test bus</span></div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        AutoTestReg             = 0x36 &lt;&lt; 1,    <span class="comment">// controls the digital self-test</span></div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        VersionReg              = 0x37 &lt;&lt; 1,    <span class="comment">// shows the software version</span></div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        AnalogTestReg           = 0x38 &lt;&lt; 1,    <span class="comment">// controls the pins AUX1 and AUX2</span></div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;        TestDAC1Reg             = 0x39 &lt;&lt; 1,    <span class="comment">// defines the test value for TestDAC1</span></div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;        TestDAC2Reg             = 0x3A &lt;&lt; 1,    <span class="comment">// defines the test value for TestDAC2</span></div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        TestADCReg              = 0x3B &lt;&lt; 1     <span class="comment">// shows the value of ADC I and Q channels</span></div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;        <span class="comment">//                        0x3C          // reserved for production tests</span></div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;        <span class="comment">//                        0x3D          // reserved for production tests</span></div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        <span class="comment">//                        0x3E          // reserved for production tests</span></div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;        <span class="comment">//                        0x3F          // reserved for production tests</span></div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    };</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    <span class="comment">// MFRC522 commands. Described in chapter 10 of the datasheet.</span></div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    <span class="keyword">enum</span> PCD_Command : <span class="keywordtype">byte</span> {</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        PCD_Idle                = 0x00,     <span class="comment">// no action, cancels current command execution</span></div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        PCD_Mem                 = 0x01,     <span class="comment">// stores 25 bytes into the internal buffer</span></div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        PCD_GenerateRandomID    = 0x02,     <span class="comment">// generates a 10-byte random ID number</span></div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;        PCD_CalcCRC             = 0x03,     <span class="comment">// activates the CRC coprocessor or performs a self-test</span></div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;        PCD_Transmit            = 0x04,     <span class="comment">// transmits data from the FIFO buffer</span></div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;        PCD_NoCmdChange         = 0x07,     <span class="comment">// no command change, can be used to modify the CommandReg register bits without affecting the command, for example, the PowerDown bit</span></div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        PCD_Receive             = 0x08,     <span class="comment">// activates the receiver circuits</span></div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        PCD_Transceive          = 0x0C,     <span class="comment">// transmits data from FIFO buffer to antenna and automatically activates the receiver after transmission</span></div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;        PCD_MFAuthent           = 0x0E,     <span class="comment">// performs the MIFARE standard authentication as a reader</span></div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;        PCD_SoftReset           = 0x0F      <span class="comment">// resets the MFRC522</span></div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    };</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;    <span class="comment">// MFRC522 RxGain[2:0] masks, defines the receiver&#39;s signal voltage gain factor (on the PCD).</span></div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    <span class="comment">// Described in 9.3.3.6 / table 98 of the datasheet at http://www.nxp.com/documents/data_sheet/MFRC522.pdf</span></div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;    <span class="keyword">enum</span> PCD_RxGain : <span class="keywordtype">byte</span> {</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        RxGain_18dB             = 0x00 &lt;&lt; 4,    <span class="comment">// 000b - 18 dB, minimum</span></div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        RxGain_23dB             = 0x01 &lt;&lt; 4,    <span class="comment">// 001b - 23 dB</span></div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        RxGain_18dB_2           = 0x02 &lt;&lt; 4,    <span class="comment">// 010b - 18 dB, it seems 010b is a duplicate for 000b</span></div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        RxGain_23dB_2           = 0x03 &lt;&lt; 4,    <span class="comment">// 011b - 23 dB, it seems 011b is a duplicate for 001b</span></div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;        RxGain_33dB             = 0x04 &lt;&lt; 4,    <span class="comment">// 100b - 33 dB, average, and typical default</span></div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        RxGain_38dB             = 0x05 &lt;&lt; 4,    <span class="comment">// 101b - 38 dB</span></div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;        RxGain_43dB             = 0x06 &lt;&lt; 4,    <span class="comment">// 110b - 43 dB</span></div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        RxGain_48dB             = 0x07 &lt;&lt; 4,    <span class="comment">// 111b - 48 dB, maximum</span></div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        RxGain_min              = 0x00 &lt;&lt; 4,    <span class="comment">// 000b - 18 dB, minimum, convenience for RxGain_18dB</span></div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        RxGain_avg              = 0x04 &lt;&lt; 4,    <span class="comment">// 100b - 33 dB, average, convenience for RxGain_33dB</span></div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        RxGain_max              = 0x07 &lt;&lt; 4     <span class="comment">// 111b - 48 dB, maximum, convenience for RxGain_48dB</span></div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    };</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;    <span class="comment">// Commands sent to the PICC.</span></div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    <span class="keyword">enum</span> PICC_Command : <span class="keywordtype">byte</span> {</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        <span class="comment">// The commands used by the PCD to manage communication with several PICCs (ISO 14443-3, Type A, section 6.4)</span></div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;        PICC_CMD_REQA           = 0x26,     <span class="comment">// REQuest command, Type A. Invites PICCs in state IDLE to go to READY and prepare for anticollision or selection. 7 bit frame.</span></div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        PICC_CMD_WUPA           = 0x52,     <span class="comment">// Wake-UP command, Type A. Invites PICCs in state IDLE and HALT to go to READY(*) and prepare for anticollision or selection. 7 bit frame.</span></div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;        PICC_CMD_CT             = 0x88,     <span class="comment">// Cascade Tag. Not really a command, but used during anti collision.</span></div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;        PICC_CMD_SEL_CL1        = 0x93,     <span class="comment">// Anti collision/Select, Cascade Level 1</span></div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        PICC_CMD_SEL_CL2        = 0x95,     <span class="comment">// Anti collision/Select, Cascade Level 2</span></div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        PICC_CMD_SEL_CL3        = 0x97,     <span class="comment">// Anti collision/Select, Cascade Level 3</span></div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        PICC_CMD_HLTA           = 0x50,     <span class="comment">// HaLT command, Type A. Instructs an ACTIVE PICC to go to state HALT.</span></div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        <span class="comment">// The commands used for MIFARE Classic (from http://www.mouser.com/ds/2/302/MF1S503x-89574.pdf, Section 9)</span></div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;        <span class="comment">// Use PCD_MFAuthent to authenticate access to a sector, then use these commands to read/write/modify the blocks on the sector.</span></div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        <span class="comment">// The read/write commands can also be used for MIFARE Ultralight.</span></div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;        PICC_CMD_MF_AUTH_KEY_A  = 0x60,     <span class="comment">// Perform authentication with Key A</span></div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        PICC_CMD_MF_AUTH_KEY_B  = 0x61,     <span class="comment">// Perform authentication with Key B</span></div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;        PICC_CMD_MF_READ        = 0x30,     <span class="comment">// Reads one 16 byte block from the authenticated sector of the PICC. Also used for MIFARE Ultralight.</span></div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;        PICC_CMD_MF_WRITE       = 0xA0,     <span class="comment">// Writes one 16 byte block to the authenticated sector of the PICC. Called &quot;COMPATIBILITY WRITE&quot; for MIFARE Ultralight.</span></div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        PICC_CMD_MF_DECREMENT   = 0xC0,     <span class="comment">// Decrements the contents of a block and stores the result in the internal data register.</span></div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        PICC_CMD_MF_INCREMENT   = 0xC1,     <span class="comment">// Increments the contents of a block and stores the result in the internal data register.</span></div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        PICC_CMD_MF_RESTORE     = 0xC2,     <span class="comment">// Reads the contents of a block into the internal data register.</span></div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        PICC_CMD_MF_TRANSFER    = 0xB0,     <span class="comment">// Writes the contents of the internal data register to a block.</span></div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;        <span class="comment">// The commands used for MIFARE Ultralight (from http://www.nxp.com/documents/data_sheet/MF0ICU1.pdf, Section 8.6)</span></div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;        <span class="comment">// The PICC_CMD_MF_READ and PICC_CMD_MF_WRITE can also be used for MIFARE Ultralight.</span></div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;        PICC_CMD_UL_WRITE       = 0xA2      <span class="comment">// Writes one 4 byte page to the PICC.</span></div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    };</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;    <span class="comment">// MIFARE constants that does not fit anywhere else</span></div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    <span class="keyword">enum</span> MIFARE_Misc {</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;        MF_ACK                  = 0xA,      <span class="comment">// The MIFARE Classic uses a 4 bit ACK/NAK. Any other value than 0xA is NAK.</span></div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        MF_KEY_SIZE             = 6         <span class="comment">// A Mifare Crypto1 key is 6 bytes.</span></div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;    };</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;    <span class="comment">// PICC types we can detect. Remember to update PICC_GetTypeName() if you add more.</span></div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    <span class="comment">// last value set to 0xff, then compiler uses less ram, it seems some optimisations are triggered</span></div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    <span class="keyword">enum</span> PICC_Type : <span class="keywordtype">byte</span> {</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;        PICC_TYPE_UNKNOWN       ,</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;        PICC_TYPE_ISO_14443_4   ,   <span class="comment">// PICC compliant with ISO/IEC 14443-4</span></div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;        PICC_TYPE_ISO_18092     ,   <span class="comment">// PICC compliant with ISO/IEC 18092 (NFC)</span></div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        PICC_TYPE_MIFARE_MINI   ,   <span class="comment">// MIFARE Classic protocol, 320 bytes</span></div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;        PICC_TYPE_MIFARE_1K     ,   <span class="comment">// MIFARE Classic protocol, 1KB</span></div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;        PICC_TYPE_MIFARE_4K     ,   <span class="comment">// MIFARE Classic protocol, 4KB</span></div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        PICC_TYPE_MIFARE_UL     ,   <span class="comment">// MIFARE Ultralight or Ultralight C</span></div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;        PICC_TYPE_MIFARE_PLUS   ,   <span class="comment">// MIFARE Plus</span></div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;        PICC_TYPE_MIFARE_DESFIRE,   <span class="comment">// MIFARE DESFire</span></div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;        PICC_TYPE_TNP3XXX       ,   <span class="comment">// Only mentioned in NXP AN 10833 MIFARE Type Identification Procedure</span></div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;        PICC_TYPE_NOT_COMPLETE  = 0xff  <span class="comment">// SAK indicates UID is not complete.</span></div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;    };</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;    <span class="comment">// Return codes from the functions in this class. Remember to update GetStatusCodeName() if you add more.</span></div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    <span class="comment">// last value set to 0xff, then compiler uses less ram, it seems some optimisations are triggered</span></div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;    <span class="keyword">enum</span> StatusCode : <span class="keywordtype">byte</span> {</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;        STATUS_OK               ,   <span class="comment">// Success</span></div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        STATUS_ERROR            ,   <span class="comment">// Error in communication</span></div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;        STATUS_COLLISION        ,   <span class="comment">// Collission detected</span></div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;        STATUS_TIMEOUT          ,   <span class="comment">// Timeout in communication.</span></div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;        STATUS_NO_ROOM          ,   <span class="comment">// A buffer is not big enough.</span></div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;        STATUS_INTERNAL_ERROR   ,   <span class="comment">// Internal error in the code. Should not happen ;-)</span></div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;        STATUS_INVALID          ,   <span class="comment">// Invalid argument.</span></div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;        STATUS_CRC_WRONG        ,   <span class="comment">// The CRC_A does not match</span></div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;        STATUS_MIFARE_NACK      = 0xff  <span class="comment">// A MIFARE PICC responded with NAK.</span></div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;    };</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;    <span class="comment">// A struct used for passing the UID of a PICC.</span></div><div class="line"><a name="l00313"></a><span class="lineno"><a class="line" href="structMFRC522_1_1Uid.html">  313</a></span>&#160;    <span class="keyword">typedef</span> <span class="keyword">struct </span>{</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;        <span class="keywordtype">byte</span>        size;           <span class="comment">// Number of bytes in the UID. 4, 7 or 10.</span></div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;        <span class="keywordtype">byte</span>        uidByte[10];</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;        <span class="keywordtype">byte</span>        sak;            <span class="comment">// The SAK (Select acknowledge) byte returned from the PICC after successful selection.</span></div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;    } <a class="code" href="structMFRC522_1_1Uid.html">Uid</a>;</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;    <span class="comment">// A struct used for passing a MIFARE Crypto1 key</span></div><div class="line"><a name="l00320"></a><span class="lineno"><a class="line" href="structMFRC522_1_1MIFARE__Key.html">  320</a></span>&#160;    <span class="keyword">typedef</span> <span class="keyword">struct </span>{</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        <span class="keywordtype">byte</span>        keyByte[MF_KEY_SIZE];</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;    } <a class="code" href="structMFRC522_1_1MIFARE__Key.html">MIFARE_Key</a>;</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;    <span class="comment">// Member variables</span></div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;    <a class="code" href="structMFRC522_1_1Uid.html">Uid</a> uid;    <span class="comment">// Used by PICC_ReadCardSerial().</span></div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    <span class="comment">// Functions for setting up the Arduino</span></div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;    <span class="comment">//MFRC522();</span></div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;    <span class="comment">// Basic interface functions for communicating with the MFRC522</span></div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#aa5e5825adb4c784d8a5a60242c135fb7">PCD_WriteRegister</a>(PCD_Register reg, <span class="keywordtype">byte</span> value);</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#aa5e5825adb4c784d8a5a60242c135fb7">PCD_WriteRegister</a>(PCD_Register reg, <span class="keywordtype">byte</span> count, <span class="keywordtype">byte</span>* values);</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;    <span class="keywordtype">byte</span> <a class="code" href="classMFRC522.html#a4289838c6f24f2d62eb8dc0e7a6647d1">PCD_ReadRegister</a>(PCD_Register reg);</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#a4289838c6f24f2d62eb8dc0e7a6647d1">PCD_ReadRegister</a>(PCD_Register reg, <span class="keywordtype">byte</span> count, <span class="keywordtype">byte</span>* values, <span class="keywordtype">byte</span> rxAlign = 0);</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#acebb9a90249419f2a53281c4a13727d1">PCD_SetRegisterBitMask</a>(PCD_Register reg, <span class="keywordtype">byte</span> mask);</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#a76193f4f8916f688fe2b7976d0fd1dc2">PCD_ClearRegisterBitMask</a>(PCD_Register reg, <span class="keywordtype">byte</span> mask);</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#a7c65647b1d72b6ee7557797322030643">PCD_CalculateCRC</a>(<span class="keywordtype">byte</span>* data, <span class="keywordtype">byte</span> length, <span class="keywordtype">byte</span>* result);</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;    <span class="comment">// Functions for manipulating the MFRC522</span></div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;<span class="comment"></span>    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#ad681e424fc68a57941bea5702cee05eb">PCD_Init</a>();</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#ad681e424fc68a57941bea5702cee05eb">PCD_Init</a>(<span class="keywordtype">byte</span> chipSelectPin, <span class="keywordtype">byte</span> resetPowerDownPin);</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#a9886678ea0a65021bf602cfb110caa15">PCD_Reset</a>();</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#a044be037a5f172e9cea7d8ce1dcf32e0">PCD_AntennaOn</a>();</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#a2098ebe85700109b20c5026643f1dad7">PCD_AntennaOff</a>();</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;    <span class="keywordtype">byte</span> <a class="code" href="classMFRC522.html#aa02ae994a9ebf146475f46fc538cef28">PCD_GetAntennaGain</a>();</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#a5ce84dd855f2ae297dd00fafaf62ef78">PCD_SetAntennaGain</a>(<span class="keywordtype">byte</span> mask);</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classMFRC522.html#a25f052c9c340da34128c365662370b01">PCD_PerformSelfTest</a>();</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;    <span class="comment">// Functions for communicating with PICCs</span></div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;<span class="comment"></span>    StatusCode <a class="code" href="classMFRC522.html#aaa96aa7ec4f95e0835cb758ad0450d74">PCD_TransceiveData</a>(<span class="keywordtype">byte</span>* sendData, <span class="keywordtype">byte</span> sendLen, <span class="keywordtype">byte</span>* backData, <span class="keywordtype">byte</span>* backLen, <span class="keywordtype">byte</span>* validBits = <span class="keyword">nullptr</span>, <span class="keywordtype">byte</span> rxAlign = 0, <span class="keywordtype">bool</span> checkCRC = <span class="keyword">false</span>);</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#acb2b1e74bc49fda2704450a684faa845">PCD_CommunicateWithPICC</a>(<span class="keywordtype">byte</span> command, <span class="keywordtype">byte</span> waitIRq, <span class="keywordtype">byte</span>* sendData, <span class="keywordtype">byte</span> sendLen, <span class="keywordtype">byte</span>* backData = <span class="keyword">nullptr</span>, <span class="keywordtype">byte</span>* backLen = <span class="keyword">nullptr</span>, <span class="keywordtype">byte</span>* validBits = <span class="keyword">nullptr</span>, <span class="keywordtype">byte</span> rxAlign = 0, <span class="keywordtype">bool</span> checkCRC = <span class="keyword">false</span>);</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#a4e0ac6edf5e8f6ade351b009278fbbc7">PICC_RequestA</a>(<span class="keywordtype">byte</span>* bufferATQA, <span class="keywordtype">byte</span>* bufferSize);</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#ad00a1efcfa6dc203ca885d43f4d02125">PICC_WakeupA</a>(<span class="keywordtype">byte</span>* bufferATQA, <span class="keywordtype">byte</span>* bufferSize);</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#a639d27ac072bc0dfa478d0957591afcc">PICC_REQA_or_WUPA</a>(<span class="keywordtype">byte</span> command, <span class="keywordtype">byte</span>* bufferATQA, <span class="keywordtype">byte</span>* bufferSize);</div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;    <span class="keyword">virtual</span> StatusCode <a class="code" href="classMFRC522.html#a7a78c629cb4e1d90cc2d7526b17d6c22">PICC_Select</a>(<a class="code" href="structMFRC522_1_1Uid.html">Uid</a>* uid, <span class="keywordtype">byte</span> validBits = 0);</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#a8874921b4ed26c5b73d89c90f76d4933">PICC_HaltA</a>();</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;    <span class="comment">// Functions for communicating with MIFARE PICCs</span></div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;<span class="comment"></span>    StatusCode <a class="code" href="classMFRC522.html#a6c2313c4aa98806cc2bf0e9cca993ec0">PCD_Authenticate</a>(<span class="keywordtype">byte</span> command, <span class="keywordtype">byte</span> blockAddr, <a class="code" href="structMFRC522_1_1MIFARE__Key.html">MIFARE_Key</a>* key, <a class="code" href="structMFRC522_1_1Uid.html">Uid</a>* uid);</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#a24d3ab7b2170fdfa3f0121a7256f12d9">PCD_StopCrypto1</a>();</div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#a6ed93e88913ea104420f3bb4a88cce52">MIFARE_Read</a>(<span class="keywordtype">byte</span> blockAddr, <span class="keywordtype">byte</span>* buffer, <span class="keywordtype">byte</span>* bufferSize);</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#a0dc5fb05769779ec3ed708bd153706b3">MIFARE_Write</a>(<span class="keywordtype">byte</span> blockAddr, <span class="keywordtype">byte</span>* buffer, <span class="keywordtype">byte</span> bufferSize);</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#a7053e61540b68e6aa5c6cbea308836c4">MIFARE_Ultralight_Write</a>(<span class="keywordtype">byte</span> page, <span class="keywordtype">byte</span>* buffer, <span class="keywordtype">byte</span> bufferSize);</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#aeab21496c761cdecb29c69f9f3fa6150">MIFARE_Decrement</a>(<span class="keywordtype">byte</span> blockAddr, int32_t delta);</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#af9566664f23d4d67efd270e42c3dc723">MIFARE_Increment</a>(<span class="keywordtype">byte</span> blockAddr, int32_t delta);</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#a946ba7e7e244f40adcb9f900d8fd3a48">MIFARE_Restore</a>(<span class="keywordtype">byte</span> blockAddr);</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#a16ee66df69fda8a3065bc9218b45de0b">MIFARE_Transfer</a>(<span class="keywordtype">byte</span> blockAddr);</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#ab4009cbdd5150b1b3a62084aa2033807">MIFARE_GetValue</a>(<span class="keywordtype">byte</span> blockAddr, int32_t* value);</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#af19fc75e9415322fbe89245ed70a784b">MIFARE_SetValue</a>(<span class="keywordtype">byte</span> blockAddr, int32_t value);</div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#acb47eb7a05ae58825b4085efeb7a09bb">PCD_NTAG216_AUTH</a>(<span class="keywordtype">byte</span>* passWord, <span class="keywordtype">byte</span> pACK[]);</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;    <span class="comment">// Support functions</span></div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;<span class="comment"></span>    StatusCode <a class="code" href="classMFRC522.html#aa88d28676b3ffb5985af8db35d39077b">PCD_MIFARE_Transceive</a>(<span class="keywordtype">byte</span>* sendData, <span class="keywordtype">byte</span> sendLen, <span class="keywordtype">bool</span> acceptTimeout = <span class="keyword">false</span>);</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;    <span class="keyword">static</span> PICC_Type <a class="code" href="classMFRC522.html#ac80a18228260bdde07dff5d4ac23bb53">PICC_GetType</a>(<span class="keywordtype">byte</span> sak);</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;    <span class="comment">// Support functions for debuging</span></div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#a41c31c6932a59646eeff470c60a4d20d">PCD_DumpVersionToSerial</a>();</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#a6f324d43c6fbbd0e260b171747186037">PICC_DumpToSerial</a>(<a class="code" href="structMFRC522_1_1Uid.html">Uid</a>* uid);</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#a3b9a2c6da6505e0ff7b58c37d7aeff37">PICC_DumpDetailsToSerial</a>(<a class="code" href="structMFRC522_1_1Uid.html">Uid</a>* uid);</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#aafba2e74124efa2d736c1672ea104190">PICC_DumpMifareClassicToSerial</a>(<a class="code" href="structMFRC522_1_1Uid.html">Uid</a>* uid, PICC_Type piccType, <a class="code" href="structMFRC522_1_1MIFARE__Key.html">MIFARE_Key</a>* key);</div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#a20c559f09927a7c5f91295f6158e4342">PICC_DumpMifareClassicSectorToSerial</a>(<a class="code" href="structMFRC522_1_1Uid.html">Uid</a>* uid, <a class="code" href="structMFRC522_1_1MIFARE__Key.html">MIFARE_Key</a>* key, <span class="keywordtype">byte</span> sector);</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#ac148d28877dd577606a28e9e7e4b6809">PICC_DumpMifareUltralightToSerial</a>();</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;</div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;    <span class="comment">// Advanced functions for MIFARE</span></div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMFRC522.html#ab8c712963189654e9bc368be8783e2ab">MIFARE_SetAccessBits</a>(<span class="keywordtype">byte</span>* accessBitBuffer, <span class="keywordtype">byte</span> g0, <span class="keywordtype">byte</span> g1, <span class="keywordtype">byte</span> g2, <span class="keywordtype">byte</span> g3);</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;</div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;    <span class="comment">// Convenience functions - does not add extra functionality</span></div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;<span class="comment"></span>    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classMFRC522.html#a3adca9d3b455c680ebcde3b74c4e567b">PICC_IsNewCardPresent</a>();</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classMFRC522.html#aab1218c71cec9cc17ee3ac8a683df106">PICC_ReadCardSerial</a>();</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;    <span class="comment">// Pins</span></div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;    <span class="keywordtype">byte</span> _chipSelectPin;        <span class="comment">// Arduino pin connected to MFRC522&#39;s SPI slave select input (Pin 24, NSS, active low)</span></div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;    <span class="keywordtype">byte</span> _resetPowerDownPin;    <span class="comment">// Arduino pin connected to MFRC522&#39;s reset and power down input (Pin 6, NRSTPD, active low)</span></div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;    <span class="comment">// Functions for communicating with MIFARE PICCs</span></div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;    StatusCode <a class="code" href="classMFRC522.html#a86cb4ad38f61b823dfe97103b1b1f9d6">MIFARE_TwoStepHelper</a>(<span class="keywordtype">byte</span> command, <span class="keywordtype">byte</span> blockAddr, int32_t data);</div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;    <a class="code" href="classSPI.html">SPI</a> m_spi;</div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;};</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classMFRC522_html_a16ee66df69fda8a3065bc9218b45de0b"><div class="ttname"><a href="classMFRC522.html#a16ee66df69fda8a3065bc9218b45de0b">MFRC522::MIFARE_Transfer</a></div><div class="ttdeci">StatusCode MIFARE_Transfer(byte blockAddr)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1039</div></div>
<div class="ttc" id="classMFRC522_html_aa5e5825adb4c784d8a5a60242c135fb7"><div class="ttname"><a href="classMFRC522.html#aa5e5825adb4c784d8a5a60242c135fb7">MFRC522::PCD_WriteRegister</a></div><div class="ttdeci">void PCD_WriteRegister(PCD_Register reg, byte value)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:47</div></div>
<div class="ttc" id="classMFRC522_html_aeab21496c761cdecb29c69f9f3fa6150"><div class="ttname"><a href="classMFRC522.html#aeab21496c761cdecb29c69f9f3fa6150">MFRC522::MIFARE_Decrement</a></div><div class="ttdeci">StatusCode MIFARE_Decrement(byte blockAddr, int32_t delta)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:969</div></div>
<div class="ttc" id="classMFRC522_html_acb2b1e74bc49fda2704450a684faa845"><div class="ttname"><a href="classMFRC522.html#acb2b1e74bc49fda2704450a684faa845">MFRC522::PCD_CommunicateWithPICC</a></div><div class="ttdeci">StatusCode PCD_CommunicateWithPICC(byte command, byte waitIRq, byte *sendData, byte sendLen, byte *backData=nullptr, byte *backLen=nullptr, byte *validBits=nullptr, byte rxAlign=0, bool checkCRC=false)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:443</div></div>
<div class="ttc" id="classMFRC522_html_a25f052c9c340da34128c365662370b01"><div class="ttname"><a href="classMFRC522.html#a25f052c9c340da34128c365662370b01">MFRC522::PCD_PerformSelfTest</a></div><div class="ttdeci">bool PCD_PerformSelfTest()</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:330</div></div>
<div class="ttc" id="classMFRC522_html_aa88d28676b3ffb5985af8db35d39077b"><div class="ttname"><a href="classMFRC522.html#aa88d28676b3ffb5985af8db35d39077b">MFRC522::PCD_MIFARE_Transceive</a></div><div class="ttdeci">StatusCode PCD_MIFARE_Transceive(byte *sendData, byte sendLen, bool acceptTimeout=false)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1167</div></div>
<div class="ttc" id="classMFRC522_html_a3adca9d3b455c680ebcde3b74c4e567b"><div class="ttname"><a href="classMFRC522.html#a3adca9d3b455c680ebcde3b74c4e567b">MFRC522::PICC_IsNewCardPresent</a></div><div class="ttdeci">virtual bool PICC_IsNewCardPresent()</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1582</div></div>
<div class="ttc" id="classSPI_html"><div class="ttname"><a href="classSPI.html">SPI</a></div><div class="ttdoc">Handle SPI protocol.</div><div class="ttdef"><b>Definition:</b> SPI.h:15</div></div>
<div class="ttc" id="classMFRC522_html_a86cb4ad38f61b823dfe97103b1b1f9d6"><div class="ttname"><a href="classMFRC522.html#a86cb4ad38f61b823dfe97103b1b1f9d6">MFRC522::MIFARE_TwoStepHelper</a></div><div class="ttdeci">StatusCode MIFARE_TwoStepHelper(byte command, byte blockAddr, int32_t data)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1013</div></div>
<div class="ttc" id="classMFRC522_html_acebb9a90249419f2a53281c4a13727d1"><div class="ttname"><a href="classMFRC522.html#acebb9a90249419f2a53281c4a13727d1">MFRC522::PCD_SetRegisterBitMask</a></div><div class="ttdeci">void PCD_SetRegisterBitMask(PCD_Register reg, byte mask)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:138</div></div>
<div class="ttc" id="structMFRC522_1_1Uid_html"><div class="ttname"><a href="structMFRC522_1_1Uid.html">MFRC522::Uid</a></div><div class="ttdef"><b>Definition:</b> MFRC522.h:313</div></div>
<div class="ttc" id="classMFRC522_html_a7a78c629cb4e1d90cc2d7526b17d6c22"><div class="ttname"><a href="classMFRC522.html#a7a78c629cb4e1d90cc2d7526b17d6c22">MFRC522::PICC_Select</a></div><div class="ttdeci">virtual StatusCode PICC_Select(Uid *uid, byte validBits=0)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:586</div></div>
<div class="ttc" id="classMFRC522_html_a76193f4f8916f688fe2b7976d0fd1dc2"><div class="ttname"><a href="classMFRC522.html#a76193f4f8916f688fe2b7976d0fd1dc2">MFRC522::PCD_ClearRegisterBitMask</a></div><div class="ttdeci">void PCD_ClearRegisterBitMask(PCD_Register reg, byte mask)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:150</div></div>
<div class="ttc" id="classMFRC522_html_a24d3ab7b2170fdfa3f0121a7256f12d9"><div class="ttname"><a href="classMFRC522.html#a24d3ab7b2170fdfa3f0121a7256f12d9">MFRC522::PCD_StopCrypto1</a></div><div class="ttdeci">void PCD_StopCrypto1()</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:854</div></div>
<div class="ttc" id="classMFRC522_html_ad681e424fc68a57941bea5702cee05eb"><div class="ttname"><a href="classMFRC522.html#ad681e424fc68a57941bea5702cee05eb">MFRC522::PCD_Init</a></div><div class="ttdeci">void PCD_Init()</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:197</div></div>
<div class="ttc" id="classMFRC522_html_a3b9a2c6da6505e0ff7b58c37d7aeff37"><div class="ttname"><a href="classMFRC522.html#a3b9a2c6da6505e0ff7b58c37d7aeff37">MFRC522::PICC_DumpDetailsToSerial</a></div><div class="ttdeci">void PICC_DumpDetailsToSerial(Uid *uid)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1304</div></div>
<div class="ttc" id="classMFRC522_html_aafba2e74124efa2d736c1672ea104190"><div class="ttname"><a href="classMFRC522.html#aafba2e74124efa2d736c1672ea104190">MFRC522::PICC_DumpMifareClassicToSerial</a></div><div class="ttdeci">void PICC_DumpMifareClassicToSerial(Uid *uid, PICC_Type piccType, MIFARE_Key *key)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1336</div></div>
<div class="ttc" id="classMFRC522_html_a9886678ea0a65021bf602cfb110caa15"><div class="ttname"><a href="classMFRC522.html#a9886678ea0a65021bf602cfb110caa15">MFRC522::PCD_Reset</a></div><div class="ttdeci">void PCD_Reset()</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:266</div></div>
<div class="ttc" id="classMFRC522_html_ab8c712963189654e9bc368be8783e2ab"><div class="ttname"><a href="classMFRC522.html#ab8c712963189654e9bc368be8783e2ab">MFRC522::MIFARE_SetAccessBits</a></div><div class="ttdeci">void MIFARE_SetAccessBits(byte *accessBitBuffer, byte g0, byte g1, byte g2, byte g3)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1561</div></div>
<div class="ttc" id="classMFRC522_html_a2098ebe85700109b20c5026643f1dad7"><div class="ttname"><a href="classMFRC522.html#a2098ebe85700109b20c5026643f1dad7">MFRC522::PCD_AntennaOff</a></div><div class="ttdeci">void PCD_AntennaOff()</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:294</div></div>
<div class="ttc" id="classMFRC522_html_ad00a1efcfa6dc203ca885d43f4d02125"><div class="ttname"><a href="classMFRC522.html#ad00a1efcfa6dc203ca885d43f4d02125">MFRC522::PICC_WakeupA</a></div><div class="ttdeci">StatusCode PICC_WakeupA(byte *bufferATQA, byte *bufferSize)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:540</div></div>
<div class="ttc" id="structMFRC522_1_1MIFARE__Key_html"><div class="ttname"><a href="structMFRC522_1_1MIFARE__Key.html">MFRC522::MIFARE_Key</a></div><div class="ttdef"><b>Definition:</b> MFRC522.h:320</div></div>
<div class="ttc" id="classMFRC522_html_a0dc5fb05769779ec3ed708bd153706b3"><div class="ttname"><a href="classMFRC522.html#a0dc5fb05769779ec3ed708bd153706b3">MFRC522::MIFARE_Write</a></div><div class="ttdeci">StatusCode MIFARE_Write(byte blockAddr, byte *buffer, byte bufferSize)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:910</div></div>
<div class="ttc" id="classMFRC522_html_a639d27ac072bc0dfa478d0957591afcc"><div class="ttname"><a href="classMFRC522.html#a639d27ac072bc0dfa478d0957591afcc">MFRC522::PICC_REQA_or_WUPA</a></div><div class="ttdeci">StatusCode PICC_REQA_or_WUPA(byte command, byte *bufferATQA, byte *bufferSize)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:554</div></div>
<div class="ttc" id="classMFRC522_html_aaa96aa7ec4f95e0835cb758ad0450d74"><div class="ttname"><a href="classMFRC522.html#aaa96aa7ec4f95e0835cb758ad0450d74">MFRC522::PCD_TransceiveData</a></div><div class="ttdeci">StatusCode PCD_TransceiveData(byte *sendData, byte sendLen, byte *backData, byte *backLen, byte *validBits=nullptr, byte rxAlign=0, bool checkCRC=false)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:422</div></div>
<div class="ttc" id="classMFRC522_html_a5ce84dd855f2ae297dd00fafaf62ef78"><div class="ttname"><a href="classMFRC522.html#a5ce84dd855f2ae297dd00fafaf62ef78">MFRC522::PCD_SetAntennaGain</a></div><div class="ttdeci">void PCD_SetAntennaGain(byte mask)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:316</div></div>
<div class="ttc" id="classMFRC522_html_a7c65647b1d72b6ee7557797322030643"><div class="ttname"><a href="classMFRC522.html#a7c65647b1d72b6ee7557797322030643">MFRC522::PCD_CalculateCRC</a></div><div class="ttdeci">StatusCode PCD_CalculateCRC(byte *data, byte length, byte *result)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:164</div></div>
<div class="ttc" id="classMFRC522_html_a946ba7e7e244f40adcb9f900d8fd3a48"><div class="ttname"><a href="classMFRC522.html#a946ba7e7e244f40adcb9f900d8fd3a48">MFRC522::MIFARE_Restore</a></div><div class="ttdeci">StatusCode MIFARE_Restore(byte blockAddr)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:998</div></div>
<div class="ttc" id="classMFRC522_html_af9566664f23d4d67efd270e42c3dc723"><div class="ttname"><a href="classMFRC522.html#af9566664f23d4d67efd270e42c3dc723">MFRC522::MIFARE_Increment</a></div><div class="ttdeci">StatusCode MIFARE_Increment(byte blockAddr, int32_t delta)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:984</div></div>
<div class="ttc" id="classMFRC522_html_af19fc75e9415322fbe89245ed70a784b"><div class="ttname"><a href="classMFRC522.html#af19fc75e9415322fbe89245ed70a784b">MFRC522::MIFARE_SetValue</a></div><div class="ttdeci">StatusCode MIFARE_SetValue(byte blockAddr, int32_t value)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1089</div></div>
<div class="ttc" id="classMFRC522_html_ac148d28877dd577606a28e9e7e4b6809"><div class="ttname"><a href="classMFRC522.html#ac148d28877dd577606a28e9e7e4b6809">MFRC522::PICC_DumpMifareUltralightToSerial</a></div><div class="ttdeci">void PICC_DumpMifareUltralightToSerial()</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1517</div></div>
<div class="ttc" id="classMFRC522_html_a7053e61540b68e6aa5c6cbea308836c4"><div class="ttname"><a href="classMFRC522.html#a7053e61540b68e6aa5c6cbea308836c4">MFRC522::MIFARE_Ultralight_Write</a></div><div class="ttdeci">StatusCode MIFARE_Ultralight_Write(byte page, byte *buffer, byte bufferSize)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:939</div></div>
<div class="ttc" id="classMFRC522_html_a044be037a5f172e9cea7d8ce1dcf32e0"><div class="ttname"><a href="classMFRC522.html#a044be037a5f172e9cea7d8ce1dcf32e0">MFRC522::PCD_AntennaOn</a></div><div class="ttdeci">void PCD_AntennaOn()</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:283</div></div>
<div class="ttc" id="classMFRC522_html_aa02ae994a9ebf146475f46fc538cef28"><div class="ttname"><a href="classMFRC522.html#aa02ae994a9ebf146475f46fc538cef28">MFRC522::PCD_GetAntennaGain</a></div><div class="ttdeci">byte PCD_GetAntennaGain()</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:306</div></div>
<div class="ttc" id="classMFRC522_html_a20c559f09927a7c5f91295f6158e4342"><div class="ttname"><a href="classMFRC522.html#a20c559f09927a7c5f91295f6158e4342">MFRC522::PICC_DumpMifareClassicSectorToSerial</a></div><div class="ttdeci">void PICC_DumpMifareClassicSectorToSerial(Uid *uid, MIFARE_Key *key, byte sector)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1376</div></div>
<div class="ttc" id="classMFRC522_html_a6ed93e88913ea104420f3bb4a88cce52"><div class="ttname"><a href="classMFRC522.html#a6ed93e88913ea104420f3bb4a88cce52">MFRC522::MIFARE_Read</a></div><div class="ttdeci">StatusCode MIFARE_Read(byte blockAddr, byte *buffer, byte *bufferSize)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:879</div></div>
<div class="ttc" id="classMFRC522_html"><div class="ttname"><a href="classMFRC522.html">MFRC522</a></div><div class="ttdef"><b>Definition:</b> MFRC522.h:137</div></div>
<div class="ttc" id="classMFRC522_html_ac80a18228260bdde07dff5d4ac23bb53"><div class="ttname"><a href="classMFRC522.html#ac80a18228260bdde07dff5d4ac23bb53">MFRC522::PICC_GetType</a></div><div class="ttdeci">static PICC_Type PICC_GetType(byte sak)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1200</div></div>
<div class="ttc" id="classMFRC522_html_a6c2313c4aa98806cc2bf0e9cca993ec0"><div class="ttname"><a href="classMFRC522.html#a6c2313c4aa98806cc2bf0e9cca993ec0">MFRC522::PCD_Authenticate</a></div><div class="ttdeci">StatusCode PCD_Authenticate(byte command, byte blockAddr, MIFARE_Key *key, Uid *uid)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:827</div></div>
<div class="ttc" id="classMFRC522_html_a41c31c6932a59646eeff470c60a4d20d"><div class="ttname"><a href="classMFRC522.html#a41c31c6932a59646eeff470c60a4d20d">MFRC522::PCD_DumpVersionToSerial</a></div><div class="ttdeci">void PCD_DumpVersionToSerial()</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1226</div></div>
<div class="ttc" id="classMFRC522_html_acb47eb7a05ae58825b4085efeb7a09bb"><div class="ttname"><a href="classMFRC522.html#acb47eb7a05ae58825b4085efeb7a09bb">MFRC522::PCD_NTAG216_AUTH</a></div><div class="ttdeci">StatusCode PCD_NTAG216_AUTH(byte *passWord, byte pACK[])</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1120</div></div>
<div class="ttc" id="classMFRC522_html_a6f324d43c6fbbd0e260b171747186037"><div class="ttname"><a href="classMFRC522.html#a6f324d43c6fbbd0e260b171747186037">MFRC522::PICC_DumpToSerial</a></div><div class="ttdeci">void PICC_DumpToSerial(Uid *uid)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1257</div></div>
<div class="ttc" id="classMFRC522_html_a4289838c6f24f2d62eb8dc0e7a6647d1"><div class="ttname"><a href="classMFRC522.html#a4289838c6f24f2d62eb8dc0e7a6647d1">MFRC522::PCD_ReadRegister</a></div><div class="ttdeci">byte PCD_ReadRegister(PCD_Register reg)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:84</div></div>
<div class="ttc" id="classMFRC522_html_a4e0ac6edf5e8f6ade351b009278fbbc7"><div class="ttname"><a href="classMFRC522.html#a4e0ac6edf5e8f6ade351b009278fbbc7">MFRC522::PICC_RequestA</a></div><div class="ttdeci">StatusCode PICC_RequestA(byte *bufferATQA, byte *bufferSize)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:527</div></div>
<div class="ttc" id="classMFRC522_html_ab4009cbdd5150b1b3a62084aa2033807"><div class="ttname"><a href="classMFRC522.html#ab4009cbdd5150b1b3a62084aa2033807">MFRC522::MIFARE_GetValue</a></div><div class="ttdeci">StatusCode MIFARE_GetValue(byte blockAddr, int32_t *value)</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1063</div></div>
<div class="ttc" id="classMFRC522_html_aab1218c71cec9cc17ee3ac8a683df106"><div class="ttname"><a href="classMFRC522.html#aab1218c71cec9cc17ee3ac8a683df106">MFRC522::PICC_ReadCardSerial</a></div><div class="ttdeci">virtual bool PICC_ReadCardSerial()</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:1605</div></div>
<div class="ttc" id="classMFRC522_html_a8874921b4ed26c5b73d89c90f76d4933"><div class="ttname"><a href="classMFRC522.html#a8874921b4ed26c5b73d89c90f76d4933">MFRC522::PICC_HaltA</a></div><div class="ttdeci">StatusCode PICC_HaltA()</div><div class="ttdef"><b>Definition:</b> MFRC522.cpp:782</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
